Index: trunk/sources/HeuristicLab.Modeling/3.2/SimpleAccuracyEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.Modeling/3.2/SimpleAccuracyEvaluator.cs	(revision 2356)
+++ trunk/sources/HeuristicLab.Modeling/3.2/SimpleAccuracyEvaluator.cs	(revision 2357)
@@ -51,6 +51,6 @@
 
       for (int sample = 0; sample < nSamples; sample++) {
-        double est = values[sample, 0];
-        double origClass = values[sample, 1];
+        double est = values[sample, ESTIMATION_INDEX];
+        double origClass = values[sample, ORIGINAL_INDEX];
         double estClass = double.NaN;
         // if estimation is lower than the smallest threshold value -> estimated class is the lower class
@@ -75,5 +75,5 @@
       int n = values.GetLength(0);
       double[] original = new double[n];
-      for (int i = 0; i < n; i++) original[i] = values[i, 1];
+      for (int i = 0; i < n; i++) original[i] = values[i, ORIGINAL_INDEX];
       return original.OrderBy(x => x).Distinct().ToArray();
     }
Index: trunk/sources/HeuristicLab.Modeling/3.2/SimpleConfusionMatrixEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.Modeling/3.2/SimpleConfusionMatrixEvaluator.cs	(revision 2356)
+++ trunk/sources/HeuristicLab.Modeling/3.2/SimpleConfusionMatrixEvaluator.cs	(revision 2357)
@@ -25,4 +25,6 @@
 namespace HeuristicLab.Modeling {
   public class SimpleConfusionMatrixEvaluator : OperatorBase {
+    protected const int ORIGINAL_INDEX = 0;
+    protected const int ESTIMATION_INDEX = 1;
     public override string Description {
       get {
@@ -55,6 +57,6 @@
       int[,] confusionMatrix = new int[classes.Length, classes.Length];
       for (int sample = 0; sample < nSamples; sample++) {
-        double est = values[sample, 0];
-        double origClass = values[sample, 1];
+        double est = values[sample, ESTIMATION_INDEX];
+        double origClass = values[sample, ORIGINAL_INDEX];
         int estClassIndex = -1;
         // if estimation is lower than the smallest threshold value -> estimated class is the lower class
Index: trunk/sources/HeuristicLab.Modeling/3.2/SimpleEvaluatorBase.cs
===================================================================
--- trunk/sources/HeuristicLab.Modeling/3.2/SimpleEvaluatorBase.cs	(revision 2356)
+++ trunk/sources/HeuristicLab.Modeling/3.2/SimpleEvaluatorBase.cs	(revision 2357)
@@ -9,4 +9,7 @@
 namespace HeuristicLab.Modeling {
   public abstract class SimpleEvaluatorBase : OperatorBase {
+    protected const int ORIGINAL_INDEX = 0;
+    protected const int ESTIMATION_INDEX = 1;
+
     public virtual string OutputVariableName {
       get { return "Quality"; }
Index: trunk/sources/HeuristicLab.Modeling/3.2/SimpleMSEEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.Modeling/3.2/SimpleMSEEvaluator.cs	(revision 2356)
+++ trunk/sources/HeuristicLab.Modeling/3.2/SimpleMSEEvaluator.cs	(revision 2357)
@@ -28,6 +28,6 @@
       double cnt = 0;
       for (int i = 0; i < values.GetLength(0); i++) {
-        double estimated = values[i, 0];
-        double target = values[i, 1];
+        double estimated = values[i, ESTIMATION_INDEX];
+        double target = values[i, ORIGINAL_INDEX];
         if (!double.IsNaN(estimated) && !double.IsInfinity(estimated) &&
             !double.IsNaN(target) && !double.IsInfinity(target)) {
Index: trunk/sources/HeuristicLab.Modeling/3.2/SimpleMeanAbsolutePercentageErrorEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.Modeling/3.2/SimpleMeanAbsolutePercentageErrorEvaluator.cs	(revision 2356)
+++ trunk/sources/HeuristicLab.Modeling/3.2/SimpleMeanAbsolutePercentageErrorEvaluator.cs	(revision 2357)
@@ -50,6 +50,6 @@
       int n = 0;
       for (int i = 0; i < values.GetLength(0); i++) {
-        double estimated = values[i, 0];
-        double original = values[i, 1];
+        double estimated = values[i, ESTIMATION_INDEX];
+        double original = values[i, ORIGINAL_INDEX];
 
         if (!double.IsNaN(estimated) && !double.IsInfinity(estimated) &&
Index: trunk/sources/HeuristicLab.Modeling/3.2/SimpleMeanAbsolutePercentageOfRangeErrorEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.Modeling/3.2/SimpleMeanAbsolutePercentageOfRangeErrorEvaluator.cs	(revision 2356)
+++ trunk/sources/HeuristicLab.Modeling/3.2/SimpleMeanAbsolutePercentageOfRangeErrorEvaluator.cs	(revision 2357)
@@ -51,5 +51,5 @@
       // copy to one-dimensional array for range calculation
       double[] originalValues = new double[values.GetLength(0)];
-      for (int i = 0; i < originalValues.Length; i++) originalValues[i] = values[i, 1];
+      for (int i = 0; i < originalValues.Length; i++) originalValues[i] = values[i, ORIGINAL_INDEX];
       double range = Statistics.Range(originalValues);
       if (double.IsInfinity(range)) throw new ArgumentException("Range of elements in values is infinity");
@@ -57,6 +57,6 @@
 
       for (int i = 0; i < values.GetLength(0); i++) {
-        double estimated = values[i, 0];
-        double original = values[i, 1];
+        double estimated = values[i, ESTIMATION_INDEX];
+        double original = values[i, ORIGINAL_INDEX];
 
         if (!double.IsNaN(estimated) && !double.IsInfinity(estimated) &&
Index: trunk/sources/HeuristicLab.Modeling/3.2/SimpleR2Evaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.Modeling/3.2/SimpleR2Evaluator.cs	(revision 2356)
+++ trunk/sources/HeuristicLab.Modeling/3.2/SimpleR2Evaluator.cs	(revision 2357)
@@ -30,6 +30,6 @@
       double cnt = 0;
       for (int i = 0; i < values.GetLength(0); i++) {
-        double estimated = values[i, 0];
-        double target = values[i, 1];
+        double estimated = values[i, ESTIMATION_INDEX];
+        double target = values[i, ORIGINAL_INDEX];
         if (!double.IsNaN(estimated) && !double.IsInfinity(estimated) &&
             !double.IsNaN(target) && !double.IsInfinity(target)) {
@@ -46,5 +46,5 @@
         double targetDeviationTotalSumOfSquares = 0;
         for (int i = 0; i < values.GetLength(0); i++) {
-          double target = values[i, 1];
+          double target = values[i, ORIGINAL_INDEX];
           if (!double.IsNaN(target) && !double.IsInfinity(target)) {
             target = target - targetMean;
Index: trunk/sources/HeuristicLab.Modeling/3.2/SimpleTheilInequalityCoefficientEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.Modeling/3.2/SimpleTheilInequalityCoefficientEvaluator.cs	(revision 2356)
+++ trunk/sources/HeuristicLab.Modeling/3.2/SimpleTheilInequalityCoefficientEvaluator.cs	(revision 2357)
@@ -57,7 +57,7 @@
       int nSamples = 0;
       for (int sample = 1; sample < n; sample++) {
-        double prevValue = values[sample - 1, 1];
-        double estimatedChange = values[sample, 0] - prevValue;
-        double originalChange = values[sample, 1] - prevValue;
+        double prevValue = values[sample - 1, ORIGINAL_INDEX];
+        double estimatedChange = values[sample, ESTIMATION_INDEX] - prevValue;
+        double originalChange = values[sample, ORIGINAL_INDEX] - prevValue;
         if (!double.IsNaN(originalChange) && !double.IsInfinity(originalChange)) {
           double error = estimatedChange - originalChange;
Index: trunk/sources/HeuristicLab.Modeling/3.2/SimpleVarianceAccountedForEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.Modeling/3.2/SimpleVarianceAccountedForEvaluator.cs	(revision 2356)
+++ trunk/sources/HeuristicLab.Modeling/3.2/SimpleVarianceAccountedForEvaluator.cs	(revision 2357)
@@ -57,6 +57,6 @@
       double[] originalTargetVariableValues = new double[n];
       for (int i = 0; i < n; i++) {
-        double estimated = values[i, 0];
-        double original = values[i, 1];
+        double estimated = values[i, ESTIMATION_INDEX];
+        double original = values[i, ORIGINAL_INDEX];
         if (!double.IsNaN(estimated) && !double.IsInfinity(estimated) &&
           !double.IsNaN(original) && !double.IsInfinity(original)) {
Index: trunk/sources/HeuristicLab.Modeling/3.2/VariableQualityImpactCalculator.cs
===================================================================
--- trunk/sources/HeuristicLab.Modeling/3.2/VariableQualityImpactCalculator.cs	(revision 2356)
+++ trunk/sources/HeuristicLab.Modeling/3.2/VariableQualityImpactCalculator.cs	(revision 2357)
@@ -87,5 +87,5 @@
       double[] targetValues = dataset.GetVariableValues(targetVariableName, start, end);
 
-      double oldMSE = CalculateMSE(predictedValues, targetValues);
+      double oldMSE = CalculateMSE(targetValues, predictedValues);
       double newMSE;
 
Index: trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SupportVectorEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SupportVectorEvaluator.cs	(revision 2356)
+++ trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SupportVectorEvaluator.cs	(revision 2357)
@@ -60,6 +60,6 @@
       double[,] values = new double[scaledProblem.Count, 2];
       for (int i = 0; i < scaledProblem.Count; i++) {
-        values[i, 0] = SVM.Prediction.Predict(modelData.Model, scaledProblem.X[i]);
-        values[i, 1] = dataset.GetValue(start + i, targetVariable);
+        values[i, 0] = dataset.GetValue(start + i, targetVariable);
+        values[i, 1] = SVM.Prediction.Predict(modelData.Model, scaledProblem.X[i]);
       }
 